

//#include <12f675.h>
#include <12f683.h>

#case

#define  CLOCK_FREQ  4000000

//////// Fuses: LP,XT,HS,EC_IO,NOWDT,WDT,CPD,NOCPD,PROTECT,NOPROTECT,NOMCLR
//////// Fuses: MCLR,PUT,NOPUT,INTRC_IO,INTRC,RC_IO,RC,BROWNOUT,NOBROWNOUT
#fuses NOWDT,NOCPD,NOPROTECT,NOMCLR,PUT,INTRC_IO,NOBROWNOUT
//#fuses NOWDT,NOCPD,NOPROTECT,MCLR,PUT,INTRC,NOBROWNOUT
#device ADC=8 WRITE_EEPROM=ASYNC
#use delay(CLOCK = CLOCK_FREQ)
#use fast_io(A)


// Tick frequency: 4MHz clock / 256 / 4
#define  TICK_FREQ  ( CLOCK_FREQ / 4.0 / 256 )

// Counter tick interval in us: 256us at 4MHz clock
#define  TICK_INTERVAL  ( 1000000 / TICK_FREQ )

// Cycle interval in tick counts
#define  CYCLE_INTERVAL_TICK(freq)  ( (int)(0.5 + TICK_FREQ / freq) )

// Duration in ms to tick counts
#define  DURATION_TICK(duration)  ( (int)(0.5 + duration * 1000 / TICK_INTERVAL) )

// Duration in ms to tick counts
#define  DURATION_TICK_L(duration)  ( (long)(0.5 + duration * 1000 / TICK_INTERVAL) )




typedef BOOLEAN BOOL;
typedef long WORD;

#define  BEGIN_GUARD_LONG_VALUE()  disable_interrupts(GLOBAL)
#define  END_GUARD_LONG_VALUE()    enable_interrupts(GLOBAL)

#define  LED_SEG_DATA(tris,data,offset,segno)  tris, data, offset, segno

//#define  LED_SEG_00  LED_SEG_DATA(0xff, 0x00, 0, 0)  // No output
#define  LED_OFF_TRIS  0xff

#define  LED_SEG_01  LED_SEG_DATA(0xdf, 0x20, 0, 0)
#define  LED_SEG_02  LED_SEG_DATA(0xfd, 0x02, 0, 2)
#define  LED_SEG_03  LED_SEG_DATA(0xfe, 0x00, 0, 3)
#define  LED_SEG_04  LED_SEG_DATA(0xef, 0x00, 0, 4)
#define  LED_SEG_05  LED_SEG_DATA(0xfb, 0x00, 0, 5)
#define  LED_SEG_06  LED_SEG_DATA(0xdf, 0x00, 0, 6)
#define  LED_SEG_07  LED_SEG_DATA(0xfb, 0x04, 1, 0)
#define  LED_SEG_08  LED_SEG_DATA(0xfe, 0x01, 1, 1)
#define  LED_SEG_09  LED_SEG_DATA(0xdd, 0x02, 1, 2)
#define  LED_SEG_10  LED_SEG_DATA(0xef, 0x10, 1, 3)
#define  LED_SEG_11  LED_SEG_DATA(0xfa, 0x04, 1, 4)
#define  LED_SEG_12  LED_SEG_DATA(0xfc, 0x01, 1, 5)
#define  LED_SEG_13  LED_SEG_DATA(0xfa, 0x01, 1, 6)
#define  LED_SEG_14  LED_SEG_DATA(0xdd, 0x20, 4, 0)
#define  LED_SEG_15  LED_SEG_DATA(0xfc, 0x02, 4, 0)
#define  LED_SEG_16  LED_SEG_DATA(0xf9, 0x04, 2, 0)
#define  LED_SEG_17  LED_SEG_DATA(0xf9, 0x02, 2, 1)
#define  LED_SEG_18  LED_SEG_DATA(0xdb, 0x20, 2, 2)
#define  LED_SEG_19  LED_SEG_DATA(0xeb, 0x10, 2, 3)
#define  LED_SEG_20  LED_SEG_DATA(0xee, 0x01, 2, 4)
#define  LED_SEG_21  LED_SEG_DATA(0xde, 0x01, 2, 5)
#define  LED_SEG_22  LED_SEG_DATA(0xee, 0x10, 2, 6)
#define  LED_SEG_23  LED_SEG_DATA(0xed, 0x10, 3, 0)
#define  LED_SEG_24  LED_SEG_DATA(0xdb, 0x04, 3, 1)
#define  LED_SEG_25  LED_SEG_DATA(0xed, 0x02, 3, 2)
#define  LED_SEG_26  LED_SEG_DATA(0xeb, 0x04, 3, 3)
#define  LED_SEG_27  LED_SEG_DATA(0xde, 0x20, 3, 4)
#define  LED_SEG_28  LED_SEG_DATA(0xcf, 0x10, 3, 5)
#define  LED_SEG_29  LED_SEG_DATA(0xcf, 0x20, 3, 6)

#define  MAX_SEGMENTS  29
#define  INTENSIFY_SEGMENTS  8

#define  SEGMENT_DATA_UNIT				4
#define  SEGMENT_DATA_TOP				0
#define  SEGMENT_DATA_SIZE				( MAX_SEGMENTS * SEGMENT_DATA_UNIT )
#define  SEGMENT_INTENSIFY_DATA_END		( INTENSIFY_SEGMENTS * SEGMENT_DATA_UNIT )

#rom 0x2100 = {
	LED_SEG_01, LED_SEG_02, LED_SEG_03, LED_SEG_04, LED_SEG_05, 
	LED_SEG_06, LED_SEG_07, LED_SEG_08, LED_SEG_09, LED_SEG_10, 
	LED_SEG_11, LED_SEG_12, LED_SEG_13, LED_SEG_14, LED_SEG_15, 
	LED_SEG_16, LED_SEG_17, LED_SEG_18, LED_SEG_19, LED_SEG_20, 
	LED_SEG_21, LED_SEG_22, LED_SEG_23, LED_SEG_24, LED_SEG_25, 
	LED_SEG_26, LED_SEG_27, LED_SEG_28, LED_SEG_29
}


#define  TIME_DATA_TOP					( SEGMENT_DATA_SIZE )
#define  TIME_DATA_CHECK_NUM			0
#define  TIME_DATA_HOUR					1
#define  TIME_DATA_MINUTE				2

#define  TIME_DATA_SIZE					3

#define  TIME_DATA_VALID				0xff

#rom 0x2100 + TIME_DATA_TOP = {
	~TIME_DATA_VALID, 0, 0
}


const BYTE g_bitpos[8] = {
	0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80
};


const BYTE g_seglight[] = {
/*	0     1     2     3     4     5     6     7     8     9		*/
	0x77, 0x24, 0x5d, 0x6d, 0x2e, 0x6b, 0x7b, 0x25, 0x7f, 0x6f,
/*	blank E/11  H/12  L/13	O/14	*/
	0x00, 0x5b, 0x3e, 0x52, 0x77
#if 0
/*	G/15  o/16  d/17  J/18  b/19	*/
	,0x73, 0x78, 0x7c, 0x74, 0x7a
#endif
};


#define  DIGIT_BLANK  10
#define  DIGIT_E      11
#define  DIGIT_H      12
#define  DIGIT_L      13
#define  DIGIT_O      14
#define  DIGIT_G      15
#define  DIGIT_o      16
#define  DIGIT_d      17
#define  DIGIT_J      18
#define  DIGIT_b      19


const BYTE hello[] = {
#if 1
	DIGIT_H, DIGIT_E, DIGIT_L, DIGIT_L, DIGIT_O, 
#else
	DIGIT_G, DIGIT_o, DIGIT_o, DIGIT_d, DIGIT_BLANK, DIGIT_J, DIGIT_o, DIGIT_b
#endif
	DIGIT_BLANK, DIGIT_BLANK, DIGIT_BLANK, DIGIT_BLANK
};



static long g_counter;

static BYTE g_time_hour;
static BYTE g_time_minute;
static int g_time_tenth_second;
static int g_time_seconds;

static int time[5] = {
	DIGIT_BLANK, DIGIT_BLANK, DIGIT_BLANK, DIGIT_BLANK, DIGIT_BLANK
};


static BOOL g_bPowerFail = TRUE;
static BOOL g_bSwitch1;
static BOOL g_bSwitch2;
static int g_tenth_second_count;

static int g_zero_cross_count_per_tenth_second;

#define  SWITCH_DEBOUNCE_TICK      DURATION_TICK(50)
#define  ZERO_CROSS_INHIBIT_TICK   DURATION_TICK(3)
#define  ZERO_CROSS_MISSING_TICK   DURATION_TICK(30)


#define  REPEAT_HOLD_TIME	10
#define  REPEAT_INTERVAL	2



void get_time_data()
{
	BYTE time_data_check_num;
	time_data_check_num = read_eeprom(TIME_DATA_TOP + TIME_DATA_CHECK_NUM);
	if (time_data_check_num == TIME_DATA_VALID) {
		g_time_hour = read_eeprom(TIME_DATA_TOP + TIME_DATA_HOUR);
		g_time_minute = read_eeprom(TIME_DATA_TOP + TIME_DATA_MINUTE);
	}
	else {
		g_time_hour = 0;
		g_time_minute = 0;
	}
	g_time_tenth_second = 0;
	g_time_seconds = 0;
}


void write_eeprom_with_verify(BYTE address, BYTE data)
{
	enable_interrupts(GLOBAL);
	for (;;) {
		write_eeprom(address, data);
		sleep();
		if (read_eeprom(address) == data) {
			break;
		}
	}
	disable_interrupts(GLOBAL);
}


void set_time_data()
{
	// Disable all peripherals
	disable_interrupts(INT_TIMER0);
	set_tris_a(LED_OFF_TRIS);
	setup_adc_ports(ALL_ANALOG);
	
	// Write time data
	write_eeprom_with_verify(TIME_DATA_TOP + TIME_DATA_CHECK_NUM, ~TIME_DATA_VALID);
	write_eeprom_with_verify(TIME_DATA_TOP + TIME_DATA_HOUR, g_time_hour);
	write_eeprom_with_verify(TIME_DATA_TOP + TIME_DATA_MINUTE, g_time_minute);
	write_eeprom_with_verify(TIME_DATA_TOP + TIME_DATA_CHECK_NUM, TIME_DATA_VALID);
	
	// Reenable peripherals
	//enable_interrupts(INT_TIMER0);
	reset_cpu();
}



long isr_get_counter()
{
	long val;
	BEGIN_GUARD_LONG_VALUE();
	val = g_counter;
	END_GUARD_LONG_VALUE();
	return val;
}


void init()
{
	setup_adc_ports(NO_ANALOGS);
	setup_timer_0(RTCC_INTERNAL | RTCC_DIV_1);
	set_timer0(0);
	enable_interrupts(INT_TIMER0);
	enable_interrupts(INT_EEPROM);
	enable_interrupts(GLOBAL);
	
	// this parameter is set temporarily for mains freq determination
	g_zero_cross_count_per_tenth_second = 1;
}


void set_time_digits_blank()
{
	time[0] = DIGIT_BLANK;
	time[1] = DIGIT_BLANK;
	time[2] = DIGIT_BLANK;
	time[3] = DIGIT_BLANK;
	time[4] = DIGIT_BLANK;
}


void set_time_digits_hours()
{
	time[0] = g_time_hour / 10;
	time[1] = g_time_hour % 10;
}


void set_time_digits_minutes()
{
	time[2] = g_time_minute / 10;
	time[3] = g_time_minute % 10;
}


void set_time_digits_all()
{
	set_time_digits_hours();
	set_time_digits_minutes();
	time[4] = g_time_tenth_second < 5 ? 8 : DIGIT_BLANK;
}


void isr_init()
{
	// wait for mains signal
	delay_ms(100);
	while (g_bPowerFail) {
	}
	
	// HELLO banner
	{
		int i;
		for (i = 0; i < sizeof(hello); ++i) {
			long last_counter;
			long counter;
			time[0] = time[1];
			time[1] = time[2];
			time[2] = time[3];
			time[3] = hello[i];
			last_counter = isr_get_counter();
			do {
				counter = isr_get_counter();
			} while (counter - last_counter < DURATION_TICK_L(300));
		}
	}
	
	// mains freq determination
	{
		long detect_start_counter;
		int detect_start_tenth_second_count;
		long counter;
		int tenth_second_count;
		int mains_freq;
		long last_counter;
		detect_start_counter = isr_get_counter();
		detect_start_tenth_second_count = g_tenth_second_count;
		do {
			counter = isr_get_counter();
		} while (counter - detect_start_counter < DURATION_TICK_L(1000));
		tenth_second_count = g_tenth_second_count;
		mains_freq = tenth_second_count - detect_start_tenth_second_count;

		time[1] = mains_freq / 100;
		time[2] = (mains_freq % 100) / 10;
		time[3] = mains_freq % 10;
		if (time[1] == 0) {
			time[1] = DIGIT_BLANK;
		}

		last_counter = isr_get_counter();
		do {
			counter = isr_get_counter();
		} while (counter - last_counter < DURATION_TICK_L(1000));
		set_time_digits_blank();
		do {
			counter = isr_get_counter();
		} while (counter - last_counter < DURATION_TICK_L(1500));
		
		if (mains_freq < 55) {
			mains_freq = 50;
		}
		else if (mains_freq < 70) {
			mains_freq = 60;
		}
		else if (mains_freq < 110) {
			mains_freq = 100;
		}
		else {
			mains_freq = 120;
		}
		g_zero_cross_count_per_tenth_second = mains_freq / 10;
		
	}
	
}


void isr_normal()
{
	BOOL last_switch1 = TRUE;
	BOOL last_switch2 = TRUE;
	for (;;) {
		static BOOL test_mode = FALSE;
		static int last_tenth_second_count;
		if (g_tenth_second_count != last_tenth_second_count) {
			last_tenth_second_count = g_tenth_second_count;
		
			// count the 1/10th second tick for every 100ms
			if (++g_time_tenth_second == 10) {
				g_time_tenth_second = 0;
				if (++g_time_seconds == 60) {
					g_time_seconds = 0;
				}
			}
			// increment minutes on the minute mark, or always increment in the test mode
			if (test_mode || (g_time_tenth_second == 0 && g_time_seconds == 0)) {
				if (++g_time_minute == 60) {
					g_time_minute = 0;
					if (++g_time_hour == 24) {
						g_time_hour = 0;
					}
				}
			}
			set_time_digits_all();
		}
		if (g_bSwitch1 != last_switch1) {
			last_switch1 = g_bSwitch1;
			if (g_bSwitch1) {
				break;
			}
		}
		if (g_bSwitch2 != last_switch2) {
			last_switch2 = g_bSwitch2;
			if (g_bSwitch2) {
				test_mode = !test_mode;
			}
		}
	}
	g_time_tenth_second = 0;
	g_time_seconds = 0;
}


void isr_set_hour()
{
	BOOL last_switch1 = TRUE;
	BOOL last_switch2 = TRUE;
	int last_tenth_second_count;
	set_time_digits_all();
	for (;;) {
		if (g_bSwitch1 != last_switch1) {
			last_switch1 = g_bSwitch1;
			if (g_bSwitch1) {
				break;
			}
		}
		if (g_bSwitch2 || g_tenth_second_count & 0x04) {
			set_time_digits_hours();
		}
		else {
			time[0] = DIGIT_BLANK;
			time[1] = DIGIT_BLANK;
		}
		
		if (g_bSwitch2 != last_switch2) {
			last_switch2 = g_bSwitch2;
			last_tenth_second_count = g_tenth_second_count;
			// increment the hour value
		}
		else if (g_tenth_second_count == last_tenth_second_count + REPEAT_HOLD_TIME) {
			last_tenth_second_count += REPEAT_INTERVAL;
			// increment the hour value
		}
		else {
			continue;
		}
		if (!g_bSwitch2) {
			continue;
		}
			
		if (++g_time_hour == 24) {
			g_time_hour = 0;
		}
	}
}


void isr_set_minute()
{
	BOOL last_switch1 = TRUE;
	BOOL last_switch2 = TRUE;
	int last_tenth_second_count;
	set_time_digits_all();
	for (;;) {
		if (g_bSwitch1 != last_switch1) {
			last_switch1 = g_bSwitch1;
			if (g_bSwitch1) {
				break;
			}
		}
		if (g_bSwitch2 || g_tenth_second_count & 0x04) {
			set_time_digits_minutes();
		}
		else {
			time[2] = DIGIT_BLANK;
			time[3] = DIGIT_BLANK;
		}
		
		if (g_bSwitch2 != last_switch2) {
			last_switch2 = g_bSwitch2;
			last_tenth_second_count = g_tenth_second_count;
			// increment the minute value
		}
		else if (g_tenth_second_count == last_tenth_second_count + REPEAT_HOLD_TIME) {
			last_tenth_second_count += REPEAT_INTERVAL;
			// increment the minute value
		}
		else {
			continue;
		}
		if (!g_bSwitch2) {
			continue;
		}
			
		if (++g_time_minute == 60) {
			g_time_minute = 0;
		}
	}
}


#int_timer0
void interrupt_timer0()
{
	static BOOL intensify;
	static BOOL led_off; // LED was set off in the previous interrupt
	static int sw1_debounce_count;
	static int sw2_debounce_count;
	static BOOL last_zero_cross_state;
	static int zero_cross_inhibit_count;
	
	++g_counter;
	
	// check switch input state ONLY WHEN LED IS NOT DRIVEN
	++sw1_debounce_count;
	++sw2_debounce_count;
	if (led_off) {
		// check switch 1
		if (input(PIN_A0) != g_bSwitch1) {
			sw1_debounce_count = 0;
		}
		else if (sw1_debounce_count >= SWITCH_DEBOUNCE_TICK) {
			g_bSwitch1 = !g_bSwitch1;
		}
		// check switch 2
		if (input(PIN_A1) != g_bSwitch2) {
			sw2_debounce_count = 0;
		}
		else if (sw2_debounce_count >= SWITCH_DEBOUNCE_TICK) {
			g_bSwitch2 = !g_bSwitch2;
		}
	}
	
	// output LED segment data
	if (intensify) {
		intensify = FALSE;
	}
	else {
		static int segment_data_ptr;
		BYTE tris;
		BYTE data;
		BYTE offset;
		BYTE segno;
		BYTE digit;
		tris = read_eeprom(segment_data_ptr);
		data = read_eeprom(segment_data_ptr + 1);
		offset = read_eeprom(segment_data_ptr + 2);
		segno = read_eeprom(segment_data_ptr + 3);
		digit = time[offset];
		if (offset == 0 && digit == 0) {
			// Hour zero blanking
			digit = DIGIT_BLANK;
		}
		if (g_seglight[digit] & g_bitpos[segno]) {
			// This segment is on
			led_off = FALSE;
		}
		else {
			// This segment is off
			tris = LED_OFF_TRIS;
			led_off = TRUE;
		}
		set_tris_a(tris);
		output_a(data);
		segment_data_ptr += SEGMENT_DATA_UNIT;
		if (segment_data_ptr == SEGMENT_DATA_SIZE) {
			segment_data_ptr = SEGMENT_DATA_TOP;
		}
		else if (segment_data_ptr < SEGMENT_INTENSIFY_DATA_END) {
			intensify = TRUE;
		}
	}
	
	// check zero-cross input state
	++zero_cross_inhibit_count;
	if (zero_cross_inhibit_count >= ZERO_CROSS_INHIBIT_TICK) {
		if (zero_cross_inhibit_count == ZERO_CROSS_MISSING_TICK) {
			zero_cross_inhibit_count = 0;
			if (!g_bPowerFail) {
				g_bPowerFail = TRUE;
				set_time_data();
			}
		}
		if (input(PIN_A3) != last_zero_cross_state) {
			last_zero_cross_state = !last_zero_cross_state;
			zero_cross_inhibit_count = 0;
			g_bPowerFail = FALSE;
			if (last_zero_cross_state) {
				static int zero_cross_counter;
				if (++zero_cross_counter == g_zero_cross_count_per_tenth_second) {
					zero_cross_counter = 0;
					++g_tenth_second_count;
				}
			}
		}
	}
}



#int_eeprom
void interrupt_eeprom()
{
}



void main()
{
	init();
	get_time_data();
	isr_init();
	for (;;) {
		isr_normal();
		isr_set_hour();
		isr_set_minute();
	}
}
